#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-10 10:19   ##
##                                 ##
#################
require(urca)


  

ARF<-function(x,lag.max=12)
	{
		data<-embed(x,(lag.max+1))
		ACF<-cor(data,use='pairwise.complete.obs')[-1,1]
		plot(ACF,type='l',ylab='Autocorrelation',xlab='Lag',lwd=5,lend=2,col='blue')
		abline(h=0)
		return(ACF=ACF)
	}
	
URruns<-function(series)
	{
		data<-ts.union(series,diff(series),lag(series,-1))
		colnames(data)<-c('Data_series','Diff_data_series','Lag_data_series')
		fit1<-lm(Data_series~Lag_data_series,data=data)
		fit2<-lm(Diff_data_series~Lag_data_series,data=data)
		list(reg1=fit1,reg2=fit2)
		}
		
		
  computer<-read.table('../Text/COMPUTER.txt',header=T)  
 attach(computer)
 
 summary(computer)
 
 y<-ch_sales
 x<-ch_comp_Purch
 y<-ts(y)
 x<-ts(x)
 time=ts(seq(1,length(x),by=1))
 

 
## Table 10.1
# tab101<-ts.union(diff(y),x,time,lag(y,-1),diff(lag(y,-1)),diff(x),diff(lag(x,-1)))
# df101<-data.frame(tab101)
# colnames(df101)<-c('d_y','x','time','yt_1','dyt_1','dx','dxt_1')
#fit101<-lm(d_y~yt_1+dyt_1+x+dx+dxt_1+time,data=df101)
#summary(fit101)
# 
# 
 
 ## Ex 10.1
 ur.df(x,lags=0,type='trend')
 ur.df(y,lags=0,type='trend')
 
 ex101<-ts.union(diff(y),x,time,lag(y,-1),diff(lag(y,-1)),diff(lag(y,-2)),diff(x),diff(lag(x,-1)),diff(lag(x,-2)))
 dfex101<-data.frame(ex101)
 colnames(dfex101)<-c('d_y','x','time','yt_1','dyt_1','dyt_2','dx','dxt_1','dxt_2')
 attach(dfex101)
fitex101a<-lm(d_y~yt_1+dyt_1+dyt_2+x+dx+dxt_1+dxt_2+time,data=dfex101)
summary(fitex101a)
fitex101b<-update(fitex101a,.~.-time)
summary(fitex101b)
fitex101c<-update(fitex101b,.~.-dxt_2)
summary(fitex101c)
fitex101d<-update(fitex101c,.~.-dxt_1)
summary(fitex101d)
fitex101e<-update(fitex101d,.~.-dyt_2)
summary(fitex101e)



detach(computer)
		
computer<-read.table('../Text/COMPUTE1.txt',header=T)  
 attach(computer)
 
 summary(computer)
 
 ## Ex 10.2
 ur.df(x,lags=0,type='trend')
 ur.df(y,lags=0,type='trend')
 
 ex102<-ts.union(diff(y),x,time,lag(y,-1),diff(lag(y,-1)),diff(lag(y,-2)),diff(x),diff(lag(x,-1)),diff(lag(x,-2)))
 dfex102<-data.frame(ex102)
 colnames(dfex101)<-c('d_y','x','time','yt_1','dyt_1','dyt_2','dx','dxt_1','dxt_2')
 
fitex102a<-lm(d_y~yt_1+dyt_1+dyt_2+x+dx+dxt_1+dxt_2+time,data=dfex102)
summary(fitex102a)
fitex102b<-update(fitex102a,.~.-time)
summary(fitex102b)
fitex102c<-update(fitex102b,.~.-dxt_2)
summary(fitex102c)
fitex102d<-update(fitex102c,.~.-dxt_1)
summary(fitex102d)
fitex102e<-update(fitex102d,.~.-dyt_2)
summary(fitex102e)

## Ex 10.3
orange<-read.table('../Text/ORANGE.txt',header=T)  
 attach(orange)
 summary(orange)


organic<-ts(organic)
regular<-ts(regular)

 ur.df(organic,lags=0,type='trend')
 ur.df(regular,lags=0,type='trend')

ofit<-lm(organic~regular)

## Runs ADF for the number of different AR processes below
k=seq(0,5)
adfk<-sapply(k,ur.df,y=ofit$residuals,type='trend')
## Test statistics


uhat<-ts(ofit$resid)
time=ts(seq(1,length(uhat)))
datauhat<-ts.union(diff(uhat),lag(uhat,-1),lag(diff(uhat),-1),lag(diff(uhat),-2),time)
colnames(datauhat)<-c('Du','u_1','Du_1','Du_2','t')
fit1<-lm(Du~t+u_1,data=datauhat)
fit2<-update(fit1,.~.+Du_1)
fit3<-update(fit2,.~.+Du_2)

summary(fit1)
summary(fit2)
summary(fit3)
detach(orange)


## Ex 10.4
longgdp<-read.table('../Text/LONGGDP.txt',header=T)  
longgdp<-ts(longgdp[,-1],start=c(1870),names=c('US','UK','CAN','OZ'))

plot(longgdp)
## US
ur.df(longgdp[,1],lags=0,'trend')

##UK
ur.df(longgdp[,2],lags=0,'trend')

##CAN
ur.df(longgdp[,3],lags=0,'trend')

##OZ
ur.df(longgdp[,4],lags=0,'trend')

fitUSUK<-lm(longgdp[,1]~longgdp[,2])
fitUSCAN<-lm(longgdp[,1]~longgdp[,3])
fitUSOZ<-lm(longgdp[,1]~longgdp[,4])


##Simple trend ADF test
ur.df(fitUSUK$resid,lags=0,'trend')
ur.df(fitUSCAN$resid,lags=0,'trend')
ur.df(fitUSOZ$resid,lags=0,'trend')

##Ex 10.5

income<-read.table('../Text/INCOME.txt',header=T)
attach(income)

summary(income)
income<-ts(income[,-1],freq=4,start=c(1954,4))

ur.df(Income,lags=0,'trend')

ur.df(Consumption,lags=0,'trend')

fitinc<-lm(Consumption~Income,data=income)
ur.df(fitinc$resid,lags=0,'trend')
ur.df(fitinc$resid,lags=1,'trend')

uhat<-ts(fitinc$resid,freq=4)


time<-ts(1:length(uhat),freq=4)

dd<-ts.union(diff(uhat),lag(uhat,-1),lag(diff(uhat),-1),lag(diff(uhat),-2),lag(diff(uhat),-3),time)

dd<-data.frame(dd)
colnames(dd)<-c('Du','u_1','Du_1','Du_2','Du_3','t')
attach(dd)
fit0<-lm(Du~u_1+Du_1+Du_2+Du_3+t)
fit1<-lm(Du~u_1+Du_1+Du_2+t)
fit2<-update(fit1,.~.-Du_2)
fit3<-update(fit2,.~.-Du_1)
fit4<-update(fit3,.~.-t)

summary(fit0)
summary(fit1)
summary(fit2)
summary(fit3)
summary(fit4)

k=seq(0,2)
sapply(k,ur.df,type='trend',y=uhat)
ur.df(uhat,lags=0,'drift')

## Ex 10.7
income<-read.table('../Text/INCOME.txt',header=T)
attach(income)

summary(income)
income<-ts(income[,-1],freq=4,start=c(1954,4))

uhat<-ts(resid(lm(income[,2]~income[,1])),freq=4,start=c(1954,4))
time<-ts(seq(1,length(uhat)),freq=4,start=c(1954,4))

newdata<-ts.union(diff(income[,1]),diff(income[,2]),uhat,lag(diff(income[,1]),-1),lag(diff(income[,1]),-2),lag(diff(income[,1]),-3),lag(diff(income[,1]),-4),lag(diff(income[,2]),-1),lag(diff(income[,2]),-2),lag(diff(income[,2]),-3),lag(diff(income[,2]),-4),time)

newdata<-data.frame(newdata);colnames(newdata)<-c('DInc','DCon','uhat','DInc_1','DInc_2','DInc_3','DInc_4','DCon_1','DCon_2','DCon_3','DCon_4','t');attach(newdata)


fit0<-lm(DCon~uhat+DCon_1+DCon_2+DCon_3+DCon_4+DInc_1+DInc_2+DInc_3+DInc_4+t,data=newdata)

fit1<-update(fit0,.~.-Dinc_4-DInc_3)
fit2<-update(fit1,.~.-DCon_4-DCon_3)
fit3<-update(fit2,.~.-t)

summary(fit0)
summary(fit1)
summary(fit2)
summary(fit3)

##Ex 10.8
WP<-read.table('../Text/WP.txt',header=T)
attach(WP)
summary(WP)
WP<-WP[,-1]
WP<-ts(WP,freq=1,start=c(1857))

plot(WP[,1:2])

## Simple ADF tests with and without drift
ur.df(WP[,1],lags=1,'trend')
ur.df(WP[,1],lags=1,'drift')
ur.df(WP[,2],lags=1,'trend')
ur.df(WP[,2],lags=1,'drift')

coint<-lm(WP[,2]~WP[,1])
uhat<-coint$resid
uhat<-ts(uhat,freq=1,start=c(1857))
ur.df(uhat,lags=1,'trend')
ur.df(uhat,lags=1,'drift')


newWP<-ts.union(diff(WP[,1]),diff(WP[,2]))
newcoint<-lm(newWP[,2]~newWP[,1])
uhat2<-newcoint$resid
uhat2<-ts(uhat2,freq=1,start=c(1858))
ur.df(uhat2,lags=1,'trend')
ur.df(uhat2,lags=1,'drift')
time<-ts(seq(1,length(uhat2)),start=c(1858),freq=1)
newWP2<-ts.union(newWP,time,lag(newWP,-1),lag(newWP,-2),lag(newWP,-3))
WP2<-data.frame(newWP2)
colnames(WP2)<-c('WInf_t','PInf_t','t','WInf_t1','PInf_t1','WInf_t2','PInf_t2','WInf_t3','PInf_t3')
attach(WP2)
fit1<-lm(PInf_t~PInf_t1+PInf_t2+PInf_t3+WInf_t+WInf_t1+WInf_t2+WInf_t3)

fit2<-update(fit1,.~.-WInf_t1-WInf_t2-WInf_t3)
fit3<-update(fit2,.~.-PInf_t2-PInf_t3)

summary(fit1);summary(fit2);summary(fit3)