#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-10 10:19   ##
##                                 ##
#################


## Creates new plots automatically for windows, mac and Linux
newgraph<-function(platform=.Platform$GUI)
{
    print(platform)
    if(platform=='Rgui')
    return(windows())
    if(platform=='AQUA')
    return(quartz())
    else
    return(x11())
    }
    
 pause<-function()
 {
    cat('Paused. Pres <Enter> to continue')
    readline()
    invisible()
    
    
    }   

## Exercise 3.1

forest<-read.table('../Text/Forest1.txt',header=T)                  ## Note that the file is different as the headers are spread over 2 lines in the original
attach(forest)
print(mean(forest))
print(sd(forest))
print(summary(forest))

sumstats<-function(data)
{
    means<-mean(data)
    sds<-sd(data)
    mins<-min(data)
    maxs<-max(data)
    list(mean=means,sd=sds,max=maxs,min=mins)
    }
    
    a<-seq(1,dim(forest)[2])
foreststats<-sapply(a,function(a){sumstats(forest[,a])})
colnames(foreststats)<-colnames(forest)

print(foreststats)    
print(cor(forest))


## Exercise 3.2

house<-read.table('../Text/HPRICE1.txt',header=T)
attach(house)
houses<-house[,c(1:3)]
a<-seq(1:dim(houses)[2])
housestats<-sapply(a,function(a){sumstats(houses[,a])})
colnames(housestats)<-colnames(house)[1:3]
print(housestats)
print(cor(houses))

house2<-house[,c(1:4)]
print(cor(house2))


## Exercise 3.4

EX34<-read.table('../Text/EX34.txt',header=T)
attach(EX34)
correlation<-cor(EX34)
print(correlation)
newgraph()
par(mfrow=c(1,3))
plot(Y,X1,main=paste('Scatter plot for variables with a correlation of',round(correlation[2],3),sep=' '))
abline(h=0,v=0)
abline(lm(X1~Y),col='red')

plot(Y,X2,main=paste('Scatter plot for variables with a correlation of',round(correlation[3],3),sep=' '))
abline(h=0,v=0)
abline(lm(X2~Y),col='red')

plot(Y,X3,main=paste('Scatter plot for variables with a correlation of',round(correlation[4],3),sep=' '))
abline(h=0,v=0)
abline(lm(X3~Y),col='red')
detach(EX34)
rm(EX34)

pause()
cormat<-read.table('../Text/cormat.txt',header=T)
attach(cormat)
correlation<-cor(cormat)
print(correlation)


## Exercise 3.5

correlation<-cor(forest)
print(correlation)
## Number of calculations off main diagonal
calc<-function(matrix)
{
    n<-(dim(matrix)[1]^2-dim(matrix)[1])/2
    
    return(n)
    }
cat(paste('Number of correlations calculated =',calc(correlation),'\n'))

correlation<-cor(house[,c(1:5)])
print(correlation)

cat(paste('Number of correlations calculated =',calc(correlation),'\n'))