#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-14 11:11   ##
##                                 ##
#################



## Creates new plots automatically for windows, mac and Linux
newgraph<-function(platform=.Platform$GUI)
{
    print(platform)
    if(platform=='Rgui')
    return(windows())
    if(platform=='AQUA')
    return(quartz())
    else
    return(x11())
    }


pause<-function()
 {
    cat('Paused. Pres <Enter> to continue')
    readline()
    invisible()
    
    
    }   

## Example

forest<-read.table('../Text/Forest1.txt',header=T)                  ## Note that the file is different as the headers are spread over 2 lines in the original
attach(forest)

fit1<-lm(Forestloss~Popdensity,data=forest)
print(summary(fit1))

electric<-read.table('../Text/ELECTRIC1.txt',header=T)          ## Note that the file is different as the headers are spread over 2 lines in the original
attach(electric)
fit2<-lm(Cost~Output)
print(summary(fit2))

advert<-read.table('../Text/ADVERT.txt',header=T)          ## Note that the file is different as the headers are spread over 2 lines in the original
attach(advert)

fit3<-lm(sales~advertising)
print(summary(fit3))

fit4<-lm(Forestloss~Cropchange)
fit5<-update(fit4,.~Pasturechange)
print(summary(fit4))
print(summary(fit5))

V<-Popdensity/100
fit6<-update(fit1,.~V)
print(summary(fit1))
print(summary(fit6))

YY<-Forestloss*10
fit7<-update(fit1,YY~.)
print(summary(fit1))
print(summary(fit7))
newgraph()
plot(Popdensity,Forestloss,main='Forest Loss and Population Density Scatterplot')
abline(fit1,col='red',lty=2)
pause()
newgraph()
plot(fit1,which=3)
pause()
res<-fit1$residuals
fits<-fit1$fitted
print(cbind(res,fits))


print(summary(fit2))
print(paste('Correlation coef Sq', round(cor(electric)[2]^2,4),'and the RSq is ',round(summary(fit2)$r.squared,4),sep=' ' ))

rs<-summary(fit1)$r.squared
cat('RSq for Forest example', rs,'\n')


## Exercise 4.6
EX46<-read.table('../Text/EX46.txt',header=T)         
attach(EX46)
Sqrtx<-sqrt(X)
newgraph()
par(mfrow=c(2,1))
plot(X,Y)
fitEX46<-lm(Y~X)
abline(fitEX46,col='red',lty=2)
plot(Sqrtx,Y)
fitEX461<-update(fitEX46,.~Sqrtx)
abline(fitEX461,col='red',lty=2)
pause()

## Exercise 4.7

elfit<-lm(Cost~Output,data=electric)
print(summary(elfit))
lelfit<-lm(log(Cost)~log(Output),data=electric)
print(summary(lelfit))
