#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-10 10:19   ##
##                                 ##
#################


## Creates new plots automatically for windows, mac and Linux
newgraph<-function(platform=.Platform$GUI)
{
    print(platform)
    if(platform=='Rgui')
    return(windows())
    if(platform=='AQUA')
    return(quartz())
    else
    return(x11())
    }
    
pause<-function()
 {
    cat('Paused. Pres <Enter> to continue')
    readline()
    invisible()
    
    
    }    
newgraph()
par(mfrow=c(2,2))   

d5_1<-read.table('../Text/Fig51.txt',header=T)

plot(d5_1$X,d5_1$Y,xlab='X',ylab='Y',main='Figure 5.1')
abline(h=0)

d5_2<-read.table('../Text/Fig52.txt',header=T)

plot(d5_2$X,d5_2$Y,xlab='X',ylab='Y',main='Figure 5.2')
abline(h=0)

d5_3<-read.table('../Text/Fig53.txt',header=T)

plot(d5_3$X,d5_3$Y,xlab='X',ylab='Y',main='Figure 5.3')
abline(h=0)

d5_4<-read.table('../Text/Fig54.txt',header=T)

plot(d5_4$X,d5_4$Y,xlab='X',ylab='Y',main='Figure 5.4',xlim=c(0,3.5))
abline(h=0)
pause()

## Examples
fit51<-lm(d5_1$Y~d5_1$X)
fit52<-lm(d5_2$Y~d5_2$X)
fit53<-lm(d5_3$Y~d5_3$X)
fit54<-lm(d5_4$Y~d5_4$X)

cat(paste(' Figure \tBeta\t 90% Conf \t 95% Conf \t\t 99% Conf \n','Fig 5.1',round(coef(fit51)[2],2),'\t[',round(confint(fit51,level=.9)[2,],2)[1],round(confint(fit51,level=.9)[2,],2)[2],']','\t[',round(confint(fit51,level=.95)[2,],2)[1],round(confint(fit51,level=.95)[2,],2)[2],']','\t[',round(confint(fit51,level=.99)[2,],2)[1],round(confint(fit51,level=.99)[2,],2)[2],']'))

cat(paste('\nFig 5.2\t',round(coef(fit52)[2],2),'\t[',round(confint(fit52,level=.9)[2,],2)[1],round(confint(fit52,level=.9)[2,],2)[2],']','\t[',round(confint(fit52,level=.95)[2,],2)[1],round(confint(fit52,level=.95)[2,],2)[2],']','\t[',round(confint(fit52,level=.99)[2,],2)[1],round(confint(fit52,level=.99)[2,],2)[2],']'))

cat(paste('\nFig 5.3\t',round(coef(fit53)[2],2),'\t\t[',round(confint(fit53,level=.9)[2,],2)[1],round(confint(fit53,level=.9)[2,],2)[2],']','\t[',round(confint(fit53,level=.95)[2,],2)[1],round(confint(fit53,level=.95)[2,],2)[2],']','\t[',round(confint(fit53,level=.99)[2,],2)[1],round(confint(fit53,level=.99)[2,],2)[2],']'))

cat(paste('\nFig 5.4\t',round(coef(fit54)[2],2),'\t[',round(confint(fit54,level=.9)[2,],2)[1],round(confint(fit54,level=.9)[2,],2)[2],']','\t[',round(confint(fit54,level=.95)[2,],2)[1],round(confint(fit54,level=.95)[2,],2)[2],']','\t[',round(confint(fit54,level=.99)[2,],2)[1],round(confint(fit54,level=.99)[2,],2)[2],']\n'))

print(summary(fit51))
print(summary(fit52))
print(summary(fit53))
print(summary(fit54))

## Example
forest<-read.table('../Text/Forest1.txt',header=T)                  ## Note that the file is different as the headers are spread over 2 lines in the original
attach(forest)

fit1<-lm(Forestloss~Popdensity,data=forest)
print(summary(fit1))
print(confint(fit1))


## Example
house<-read.table('../Text/HPRICE1.txt',header=T)
attach(house)
fit2<-lm(saleprice~lotsize)

print(summary(fit2))
print(confint(fit2))


## Exercise 5.2
advert<-read.table('../Text/ADVERT.txt',header=T)          ## Note that the file is different as the headers are spread over 2 lines in the original
attach(advert)

fit3<-lm(sales~advertising)
print(summary(fit3))
print(confint(fit3,level=0.95))


## Exercise 5.3
electric<-read.table('../Text/ELECTRIC1.txt',header=T)          ## Note that the file is different as the headers are spread over 2 lines in the original
attach(electric)
fit4<-lm(Cost~Output)
print(summary(fit4))
print(confint(fit4))



## Example t tests

print(summary(fit1))

## Exercise 5.4

cat('For test of alpha, t statistic=',round(summary(fit1)$coefficients[1,3],3),' and p-value=',round(summary(fit1)$coefficients[1,4],3),'\n')

## Exercise 5.5

fit55<-lm(Forestloss~Cropchange)
print(summary(fit55))

fit55a<-update(fit55,.~Pasturechange)
print(summary(fit55a))


## Exercise 5.6
print('Confidence Intervals for Beta')
print(confint(fit51)[2,])
print(confint(fit52)[2,])
print(confint(fit53)[2,])
print(confint(fit54)[2,])
print('Pvalues on beta')
print(summary(fit51)$coefficients[2,4])
print(summary(fit52)$coefficients[2,4])
print(summary(fit53)$coefficients[2,4])
print(summary(fit54)$coefficients[2,4])

print('Confidence Intervals for Alpha')
print(confint(fit51)[1,])
print(confint(fit52)[1,])
print(confint(fit53)[1,])
print(confint(fit54)[1,])
print('Pvalues on beta')
print(summary(fit51)$coefficients[1,4])
print(summary(fit52)$coefficients[1,4])
print(summary(fit53)$coefficients[1,4])
print(summary(fit54)$coefficients[1,4])

print('Confidence Intervals for Alpha & Beta at 1%')
print(confint(fit51,level=.99))
print(confint(fit52,level=.99))
print(confint(fit53,level=.99))
print(confint(fit54,level=.99))


## Exercise 5.7

summary(fit3)


## Exercise 5.8
print(summary(fit51))
cat('F statistic=', summary(fit51)$fstatistic[1],' associated p-value= ',1-pf(summary(fit51)$fstatistic[1],summary(fit51)$fstatistic[2],summary(fit51)$fstatistic[3]),'\n')

print(summary(fit52))
cat('F statistic=', summary(fit52)$fstatistic[1],' associated p-value= ',1-pf(summary(fit52)$fstatistic[1],summary(fit52)$fstatistic[2],summary(fit52)$fstatistic[3]),'\n')

print(summary(fit53))
cat('F statistic=', summary(fit53)$fstatistic[1],' associated p-value= ',1-pf(summary(fit53)$fstatistic[1],summary(fit53)$fstatistic[2],summary(fit53)$fstatistic[3]),'\n')

print(summary(fit54))
cat('F statistic=', summary(fit54)$fstatistic[1],' associated p-value= ',1-pf(summary(fit54)$fstatistic[1],summary(fit54)$fstatistic[2],summary(fit54)$fstatistic[3]),'\n')

