#################
## Code for use with      ##
## Gary Koop's book      ##
## Analysis of                ##
## Economic data 2Ed   ##
##                                ##
## K Shutes                  ##
## 2008-03-10 10:19   ##
##                                 ##
#################


## Creates new plots automatically for windows, mac and Linux
#newgraph<-function(platform=.Platform$GUI)
#{
#    print(platform)
#    if(platform=='Rgui')
#    return(windows())
#    if(platform=='AQUA')
#    return(quartz())
#    else
#    return(x11())
#    }
    
 pause<-function()
 {
    cat('Paused. Pres <Enter> to continue')
    readline()
    invisible()
    
    
    }   
  

ARF<-function(x,lag.max=12)
	{
		data<-embed(x,(lag.max+1))
		ACF<-cor(data,use='pairwise.complete.obs')[-1,1]
		plot(ACF,type='h',ylab='Autocorrelation',xlab='Lag',lwd=5,lend=2,col='blue')
		abline(h=0)
		return(ACF=ACF)
	}
	
URruns<-function(series)
	{
		data<-ts.intersect(series,diff(series),lag(series,-1))
		colnames(data)<-c('Data_series','Diff_data_series','Lag_data_series')
		fit1<-lm(Data_series~Lag_data_series,data=data)
		fit2<-lm(Diff_data_series~Lag_data_series,data=data)
		list(reg1=fit1,reg2=fit2)
		}
		
		
    USINC<-read.table('../Text/INCOME.txt',header=T)  
    attach(USINC)
    USINC<-ts(USINC,freq=4,start=c(1954,1))
    
    
    ## Fig 9.1
    par(mfrow=c(2,1))
    plot(USINC[,2],xlab='Year',ylab='Log of Personal Income',col='red')
    diffUSINC<-diff(USINC)
    plot(diffUSINC[,2],xlab='Year',ylab='%Change in Personal Income',col='red')
    abline(h=0)
    
    
    ## Ex 9.1
    summary(USINC[,2:3])
    var(USINC[,2:3])
    cor(USINC[,2:3])
    
    summary(diffUSINC[,2:3])
    var(diffUSINC[,2:3])
    cor(diffUSINC[,2:3])
    
    
    par(mfrow=c(2,1))
    plot(USINC[,3],xlab='Year',ylab='Log of Personal Consumption',col='red')
    diffUSINC<-diff(USINC)
    plot(diffUSINC[,3],xlab='Year',ylab='%Change in Personal Consumption',col='red')
    abline(h=0)
    
    
    ##Ex 9.2
    
    PINC<-ts.union(USINC[,2],lag(USINC[,2],-1))
    colnames(PINC)<-c('Pers Inc','Pers Inc t-1')
    PCONS<-ts.union(USINC[,3],lag(USINC[,3],-1))
    colnames(PCONS)<-c('Pers Cons','Pers Cons t-1')
    
    par(mfrow=c(2,1))
    plot(PINC[,1],PINC[,2],xlab=colnames(PINC)[1],ylab=colnames(PINC)[2])
    plot(PCONS[,1],PCONS[,2],xlab=colnames(PCONS)[1],ylab=colnames(PCONS)[2])
     
	cor(PINC,use='pairwise.complete.obs')
	cor(PCONS,use='pairwise.complete.obs')
	
    PINCdiff<-ts.union(diffUSINC[,2],lag(diffUSINC[,2],-1))
    colnames(PINCdiff)<-c('Diff Pers Inc','Diff Pers Inc t-1')
    PCONSdiff<-ts.union(diffUSINC[,3],lag(diffUSINC[,3],-1))
    colnames(PCONSdiff)<-c('Diff Pers Cons','Diff Pers Cons t-1')	
    
        par(mfrow=c(2,1))
    plot(PINCdiff[,1],PINCdiff[,2],xlab=colnames(PINCdiff)[1],ylab=colnames(PINCdiff)[2])
    plot(PCONSdiff[,1],PCONSdiff[,2],xlab=colnames(PCONSdiff)[1],ylab=colnames(PCONSdiff)[2])
     
	cor(PINCdiff,use='pairwise.complete.obs')
	cor(PCONSdiff,use='pairwise.complete.obs')
	
	##Tab 9.1 - Note this is different from acf(USINC[,2])
	## Figures 9.3 and 9.4
	dev.off()
	ARF(USINC[,2],12)
	ARF(diffUSINC[,2],12)
	
	cor(embed(USINC[,2],13),use='pairwise.complete.obs')[-1,1]
	cor(embed(diffUSINC[,2],13),use='pairwise.complete.obs')[-1,1]
	
	
	
	
	##Ex 9.3
	ARF(USINC[,3],5)
	ARF(diffUSINC[,3],5)
	
	
	##Figs 9.5-9.7
	
	fig95<-read.table('../Text/FIG95.txt',header=T)  
	fig95<-ts(fig95)[,2]
	par(mfrow=c(3,1))
	plot(fig95,type='l',main='AR(1) series with phi=0')
	fig96<-read.table('../Text/FIG96.txt',header=T)  
	fig96<-ts(fig96)[,2]
	plot(fig96,type='l',main='AR(1) series with phi=0.8')
	fig97<-read.table('../Text/FIG97.txt',header=T)  
	fig97<-ts(fig97)[,2]
	plot(fig97,type='l',main='AR(1) series with phi=1')
	
	
	
	ARF(fig95,4)
	ARF(fig96,4)
	ARF(fig97,4)
	
	##Ex 9.5
	
	tsgrand<-ts.intersect(USINC[,2:3],diffUSINC[,2:3],lag(USINC[,2:3],-1))
	colnames(tsgrand)=c('Pers_Inc','Pers_Cons','Diff_Pers_Inc','Diff_Pers_Cons','Lag_Pers_Inc','Lag_Pers_Cons')
	
	
	fitar1<-lm(Pers_Inc~Lag_Pers_Inc,data=tsgrand)
	summary(fitar1)
	fitar2<-lm(Diff_Pers_Inc~Lag_Pers_Inc,data=tsgrand)
	summary(fitar2)
	
	tsfit95<-ts.intersect(fig95,diff(fig95),lag(fig95,-1))
	colnames(tsfit95)=c('Fig95','Diff_Fig95','Lag_Fig95')
	summary(lm(Fig95~Lag_Fig95,data=tsfit95))
	summary(lm(Diff_Fig95~Lag_Fig95,data=tsfit95))
	

		
		completerun<-apply(cbind(fig95,fig96,fig97),2,URruns)
		completerun
		
		##To extract summaries use summary(completerun$fig95$reg1) or equivalent
		
		fig98<-read.table('../Text/FIG98.txt',header=T)  
		ARF(fig98$stat)
		
		
		##
		tsUSINC<-ts.union(USINC[,2],diff(USINC[,2]),lag(USINC[,2],-1),diff(lag(USINC[,2],-1)),diff(lag(USINC[,2],-2)),diff(lag(USINC[,2],-3)),USINC[,1])
		colnames(tsUSINC)=c('INC','DINC','INCt_1','DINCt_1','DINCt_2','DINCt_3','Time')
		
		fit92<- lm(DINC~INCt_1+DINCt_1+DINCt_2+DINCt_3+Time,data=tsUSINC)
		summary(fit92)
		
		fit93<- lm(DINC~INCt_1,data=tsUSINC)
		summary(fit93)
		
		dataprep<-function(dataset)
		{
			time<-ts(1:length(dataset))
			tsSeries<-ts.union(diff(dataset),lag(dataset,-1),diff(lag(dataset,-1)),diff(lag(dataset,-2)),diff(lag(dataset,-3)),time)
			colnames(tsSeries)=c('DY','Yt_1','DYt_1','DYt_2','DYt_3','Time')
			tsSeries
		}	
		
		####Check this
		modelrun<-function(indata)
		{
			p<-0.05
			dataseta<-dataprep(indata)
			dataseta
			fit1<-lm(DY~Yt_1+DYt_1+DYt_2+DYt_3+Time,data=dataseta)
			if
			(summary((fit1))$coef[5,4]<p)
			{(fit1)}
			else
			{fit2<-lm(DY~Yt_1+DYt_1+DYt_2+Time,data=dataseta)
				if
					(summary((fit2))$coef[4,4]<p)
					{(fit2)}
			else
			{
			fit3<-lm(DY~Yt_1+DYt_1+Time,data=dataseta)
				if
					(summary((fit3))$coef[3,4]<p)
					{(fit3)}
			else
			{
			fit4<-lm(DY~Yt_1+Time,data=dataseta)
			if
			(summary((fit4))$coef[3,4]<p)
			{(fit4)}
			else
			{
			fit5<-lm(DY~Yt_1,data=dataseta)
			(fit5)
			}}}}
			
			#list(fit1=fit1,fit2=fit2,fit3=fit3,fit4=fit4,fit5=fit5)
		
		}
		
		
		adfmodelrun<-function(indata)
		{
			fit<-modelrun(indata)
			p=ifelse(any(attr(summary(fit)$terms,'term.labels')=='Time'),-3.45,-2.89)
			ifelse(summary(fit)$coef[2,3]>p,'Unit Root','No Unit Root')
			
		
		}
		
		
		modelrun(fig95)
		modelrun(fig96)
		modelrun(fig97)
		fig98<-ts(fig98)
		modelrun(fig98)
		modelrun(ts(USINC[,3]))
		
		adfmodelrun(fig95)
		adfmodelrun(fig96)
		adfmodelrun(fig97)
		fig98<-ts(fig98)[,2]
		adfmodelrun(fig98)
		adfmodelrun(ts(USINC[,3]))
		adfmodelrun(diff(ts(USINC[,2])))
		adfmodelrun(diff(ts(USINC[,3])))
		
		
		require(tseries)
		adf.test(fig95)
		adf.test(fig96)
		adf.test(fig97)
		adf.test(fig98)
		adf.test(ts(USINC[,3]))